

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.15.9. highlight_html &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.15.10. html_untag" href="html_untag.html" />
    <link rel="prev" title="7.15.8. highlight_full" href="highlight_full.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/functions/highlight_html.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="html_untag.html" title="7.15.10. html_untag"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="highlight_full.html" title="7.15.8. highlight_full"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" accesskey="U"><span class="section-number">7.15. </span>Function</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.9. </span><code class="docutils literal notranslate"><span class="pre">highlight_html</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="highlight-html">
<h1><span class="section-number">7.15.9. </span><code class="docutils literal notranslate"><span class="pre">highlight_html</span></code><a class="headerlink" href="#highlight-html" title="Permalink to this headline">¶</a></h1>
<div class="versionadded">
<p><span class="versionmodified added">New in version 4.0.5.</span></p>
</div>
<div class="section" id="summary">
<h2><span class="section-number">7.15.9.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">highlight_html</span></code> tags target text. It can use to highlight the search
keywords. The tagged text are prepared for embedding HTML. Special
characters such as <code class="docutils literal notranslate"><span class="pre">&lt;</span></code> and <code class="docutils literal notranslate"><span class="pre">&gt;</span></code> are escapsed as <code class="docutils literal notranslate"><span class="pre">&amp;lt;</span></code> and <code class="docutils literal notranslate"><span class="pre">&amp;gt;</span></code>.
Keyword is surrounded with <code class="docutils literal notranslate"><span class="pre">&lt;span</span> <span class="pre">class=&quot;keyword&quot;&gt;</span></code> and <code class="docutils literal notranslate"><span class="pre">&lt;/span&gt;</span></code>.
For example, a tagged text of <code class="docutils literal notranslate"><span class="pre">I</span> <span class="pre">am</span> <span class="pre">a</span> <span class="pre">groonga</span> <span class="pre">user.</span> <span class="pre">&lt;3</span></code> for keyword
<code class="docutils literal notranslate"><span class="pre">groonga</span></code> is <code class="docutils literal notranslate"><span class="pre">I</span> <span class="pre">am</span> <span class="pre">a</span> <span class="pre">&lt;span</span> <span class="pre">class=&quot;keyword&quot;&gt;groonga&lt;/span&gt;</span> <span class="pre">user.</span> <span class="pre">&amp;lt;3</span></code>.</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.15.9.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p>This function has only one parameter:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>highlight_html(text)
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.15.9.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>Here are a schema definition and sample data to show usage.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Entries TABLE_NO_KEY
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Entries body COLUMN_SCALAR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Terms TABLE_PAT_KEY ShortText --default_tokenizer TokenBigram --normalizer NormalizerAuto
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Terms document_index COLUMN_INDEX|WITH_POSITION Entries body
# [[0, 1337566253.89858, 0.000355720520019531], true]
load --table Entries
[
{&quot;body&quot;: &quot;Mroonga is a ＭｙＳＱＬ storage engine based on Groonga. &lt;b&gt;Rroonga&lt;/b&gt; is a Ruby binding of Groonga.&quot;}
]
# [[0, 1337566253.89858, 0.000355720520019531], 1]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">highlight_html</span></code> can be used in only <code class="docutils literal notranslate"><span class="pre">--output_columns</span></code> in
<a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> before version 10.0.6 (exclusive).
However, it can be also used in <code class="docutils literal notranslate"><span class="pre">--output_columns</span></code> in
<a class="reference internal" href="../commands/logical_select.html"><span class="doc">logical_select</span></a> since version 10.0.6.</p>
<p><code class="docutils literal notranslate"><span class="pre">highlight_html</span></code> requires <a class="reference internal" href="../command/command_version.html"><span class="doc">Command version</span></a> 2
or later.</p>
<p>You also need to specify <code class="docutils literal notranslate"><span class="pre">--query</span></code> and/or <code class="docutils literal notranslate"><span class="pre">--filter</span></code>. Keywords are
extracted from <code class="docutils literal notranslate"><span class="pre">--query</span></code> and <code class="docutils literal notranslate"><span class="pre">--filter</span></code> arguments.</p>
<p>The following example uses <code class="docutils literal notranslate"><span class="pre">--query</span> <span class="pre">&quot;groonga</span> <span class="pre">mysql&quot;</span></code>. In this case,
<code class="docutils literal notranslate"><span class="pre">groonga</span></code> and <code class="docutils literal notranslate"><span class="pre">mysql</span></code> are used as keywords.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Entries --output_columns --match_columns body --query &#39;groonga mysql&#39; --output_columns &#39;highlight_html(body)&#39; --command_version 2
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;highlight_html&quot;,
#           null
#         ]
#       ],
#       [
#         &quot;Mroonga is a &lt;span class=\&quot;keyword\&quot;&gt;ＭｙＳＱＬ&lt;/span&gt; storage engine based on &lt;span class=\&quot;keyword\&quot;&gt;Groonga&lt;/span&gt;. &amp;lt;b&amp;gt;Rroonga&amp;lt;/b&amp;gt; is a Ruby binding of &lt;span class=\&quot;keyword\&quot;&gt;Groonga&lt;/span&gt;.&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>The text are scanned by the keywords for tagging after they are normalized
by <code class="docutils literal notranslate"><span class="pre">NormalizerAuto</span></code> normalizer.</p>
<p><code class="docutils literal notranslate"><span class="pre">--query</span> <span class="pre">&quot;groonga</span> <span class="pre">mysql&quot;</span></code> matches to only the first record’s body.
<code class="docutils literal notranslate"><span class="pre">highlight_html(body)</span></code> surrounds the keywords <code class="docutils literal notranslate"><span class="pre">groonga</span></code> or <code class="docutils literal notranslate"><span class="pre">mysql</span></code>
contained in the text with <code class="docutils literal notranslate"><span class="pre">&lt;span</span> <span class="pre">class=&quot;keyword&quot;&gt;</span></code> and <code class="docutils literal notranslate"><span class="pre">&lt;/span&gt;</span></code>.</p>
<p>You can specify string literal instead of column.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Entries --output_columns &#39;highlight_html(&quot;Groonga is very fast fulltext search engine.&quot;)&#39; --command_version 2 --match_columns body --query &quot;groonga&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;highlight_html&quot;,
#           null
#         ]
#       ],
#       [
#         &quot;&lt;span class=\&quot;keyword\&quot;&gt;Groonga&lt;/span&gt; is very fast fulltext search engine.&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.15.9.4. </span>Parameters<a class="headerlink" href="#parameters" title="Permalink to this headline">¶</a></h2>
<p>This section describes all parameters.</p>
<div class="section" id="required-parameters">
<h3><span class="section-number">7.15.9.4.1. </span>Required parameters<a class="headerlink" href="#required-parameters" title="Permalink to this headline">¶</a></h3>
<p>There is only one required parameter.</p>
<div class="section" id="text">
<h4><span class="section-number">7.15.9.4.1.1. </span><code class="docutils literal notranslate"><span class="pre">text</span></code><a class="headerlink" href="#text" title="Permalink to this headline">¶</a></h4>
<p>The text to be highlighted in HTML.</p>
</div>
</div>
<div class="section" id="optional-parameters">
<h3><span class="section-number">7.15.9.4.2. </span>Optional parameters<a class="headerlink" href="#optional-parameters" title="Permalink to this headline">¶</a></h3>
<p>There is no optional parameter.</p>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.15.9.5. </span>Return value<a class="headerlink" href="#return-value" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">highlight_html</span></code> returns a tagged string or <code class="docutils literal notranslate"><span class="pre">null</span></code>. If
<code class="docutils literal notranslate"><span class="pre">highlight_html</span></code> can’t find any keywords, it returns <code class="docutils literal notranslate"><span class="pre">null</span></code>.</p>
</div>
<div class="section" id="see-also">
<h2><span class="section-number">7.15.9.6. </span>See also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
<ul class="simple">
<li><p><a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a></p></li>
<li><p><a class="reference internal" href="../commands/logical_select.html"><span class="doc">logical_select</span></a></p></li>
<li><p><a class="reference internal" href="highlight_full.html"><span class="doc">highlight_full</span></a></p></li>
</ul>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.15.9. <code class="docutils literal notranslate"><span class="pre">highlight_html</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.15.9.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.15.9.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.15.9.3. Usage</a></li>
<li><a class="reference internal" href="#parameters">7.15.9.4. Parameters</a><ul>
<li><a class="reference internal" href="#required-parameters">7.15.9.4.1. Required parameters</a><ul>
<li><a class="reference internal" href="#text">7.15.9.4.1.1. <code class="docutils literal notranslate"><span class="pre">text</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#optional-parameters">7.15.9.4.2. Optional parameters</a></li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.15.9.5. Return value</a></li>
<li><a class="reference internal" href="#see-also">7.15.9.6. See also</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="highlight_full.html"
                        title="previous chapter"><span class="section-number">7.15.8. </span><code class="docutils literal notranslate"><span class="pre">highlight_full</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="html_untag.html"
                        title="next chapter"><span class="section-number">7.15.10. </span><code class="docutils literal notranslate"><span class="pre">html_untag</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="html_untag.html" title="7.15.10. html_untag"
             >next</a> |</li>
        <li class="right" >
          <a href="highlight_full.html" title="7.15.8. highlight_full"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" ><span class="section-number">7.15. </span>Function</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.9. </span><code class="docutils literal notranslate"><span class="pre">highlight_html</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>